#!/usr/bin/perl
#########################################################################
#  Access Stats v1.0                                                    #
#  Copyright (c)2000 bp135                                              #
#  URL: http://bp135.cjb.net                                            #
#                                                                       #
# This program is free software. It may be used and modified free       #
# of charge for personal, academic or non-profit use. By using this     #
# script you agree to indemnify bp135 from any liability.               #
# Please do not remove this copyright notice.                           #
#                                                                       #
# Use:                                                                  #
#     <img src="http://www.host.com/cgi-bin/log.pl" width=1 height=1>   #
#                                                                       #
# The latest version can be downloaded from http://bp135.cjb.net        #
#########################################################################

# url to a gif file
$output = "http://localhost/~bp135/blank.gif";

# path to the log files without trailing "/"
$base_dir = "/home/usr/bp135/logfiles";

# log file extension
$log_file_ext = "log";

# Done
###########
&get_host();

@months = ('January','February','March','April','May','June','July','August','September','October','November','December');
@days = ('Sun','Mon','Tue','Wed','Thu','Fri','Sat');

($min,$hour,$mday,$mon,$year,$wday) = (localtime(time))[1,2,3,4,5,6];
$min = "0$min" if ($min < 10);
$hour = "0$hour" if ($hour < 10);
$mday = "0$mday" if ($mday < 10);
$year += 1900;

$month = $mon+1;
$month = "0$month" if ($month < 10);

$logdat = "$base_dir/$month-$year\.$log_file_ext";
$this_day = ("$days[$wday] $mday-$months[$mon]-$year $hour:$min");

open(DATA,">>$logdat");
print DATA ("$this_day - $ENV{'REMOTE_ADDR'} - $host - \"$ENV{'HTTP_USER_AGENT'}\"\n");
close (DATA);

print "Location: $output\n\n";
exit (0);

# subroutine
sub get_host {

	my ($ip_address,$ip_number,@numbers);
	if ($ENV{'REMOTE_HOST'}) {
		$host = $ENV{'REMOTE_HOST'};
	}
	else { 
		$ip_address = $ENV{'REMOTE_ADDR'};
		@numbers = split(/\./, $ip_address);
		$ip_number = pack("C4", @numbers);
		$host = (gethostbyaddr($ip_number, 2))[0];
	}
	if ($host eq "") {
		$host = "$ENV{'REMOTE_ADDR'}";
	}
}
